import {ActionBase, ActionType} from '../../reducers/systemSettingsSite/systemSettingsSiteActionTypes'
import {MultiActions} from '../types'
import {
  getAllDefaultGroupsAsync,
  getAllDefaultRolesAsync,
  getInitialSystemSettingsAsync,
  getSystemSettingsAsync
} from './systemSettingsCrudActions'
import {
  ResetAction, SET_customProjectTestCompileTimeoutInMsAction,
  SET_customProjectTestMaxDiskSpaceInKbAction,
  SET_customProjectTestMemoryLimitInKbAction,
  SET_customProjectTestTimeoutInMsAction,
  SET_defaultGroupCreatorGroupRoleIdAction,
  SET_defaultGroupRoleIdAction,
  SET_defaultUserGroupIdAction, SET_justRunProgramCompileTimeoutInMsAction,
  SET_justRunProgramMaxDiskSpaceInKbAction,
  SET_justRunProgramMemoryLimitInKbAction,
  SET_justRunProgramTimeoutInMsAction,
  SET_maxCustomProjectsPerUserAction,
  SET_maxCustomTestsPerParticipationAction,
  SET_maxNumberOfTestsWithOneRequestAction,
  SET_maxNumberOfTestsWithOneRequestSubmitTestServerAction,
  SET_serverMessageAction,
  SET_submitTestServerTimeoutInMsAction,
  SET_submitTestServerUrlAction,
  SET_testServerConfigUiUrlAction,
  SET_testServerStatsUrlAction,
  SET_testServerTimeoutInMsAction,
  SET_testServerUrlAction
} from '../../reducers/systemSettingsSite/systemSettingsSiteReducer'


export function setServerMessage(serverMessage: string): SET_serverMessageAction {
  return {
    type: ActionType.SET_serverMessage,
    serverMessage
  }
}


export function setServerMaxCustomProjectsPerUser(maxCustomProjectsPerUser: number): SET_maxCustomProjectsPerUserAction {
  return {
    type: ActionType.SET_maxCustomProjectsPerUser,
    maxCustomProjectsPerUser
  }
}

export function setServerMaxCustomTestsPerParticipation(maxCustomTestsPerParticipation: number): SET_maxCustomTestsPerParticipationAction {
  return {
    type: ActionType.SET_maxCustomTestsPerParticipation,
    maxCustomTestsPerParticipation
  }
}

export function setServerTestServerUrl(testServerUrl: string): SET_testServerUrlAction {
  return {
    type: ActionType.SET_testServerUrl,
    testServerUrl
  }
}

export function setServerTestServerStatsUrl(testServerStatsUrl: string): SET_testServerStatsUrlAction {
  return {
    type: ActionType.SET_testServerStatsUrl,
    testServerStatsUrl
  }
}

export function setServerSubmitTestServerUrl(submitTestServerUrl: string): SET_submitTestServerUrlAction {
  return {
    type: ActionType.SET_submitTestServerUrl,
    submitTestServerUrl
  }
}

export function setTestServerConfigUiUrl(testServerConfigUiUrl: string): SET_testServerConfigUiUrlAction {
  return {
    type: ActionType.SET_testServerConfigUiUrl,
    testServerConfigUiUrl
  }
}


export function setServerTestServerTimeoutInMs(testServerTimeoutInMs: number): SET_testServerTimeoutInMsAction {
  return {
    type: ActionType.SET_testServerTimeoutInMs,
    testServerTimeoutInMs
  }
}

export function setServerSubmitTestServerTimeoutInMs(submitTestServerTimeoutInMs: number): SET_submitTestServerTimeoutInMsAction {
  return {
    type: ActionType.SET_submitTestServerTimeoutInMs,
    submitTestServerTimeoutInMs
  }
}

export function setServerMaxNumberOfTestsWithOneRequest(maxNumberOfTestsWithOneRequest: number): SET_maxNumberOfTestsWithOneRequestAction {
  return {
    type: ActionType.SET_maxNumberOfTestsWithOneRequest,
    maxNumberOfTestsWithOneRequest
  }
}

export function setServerMaxNumberOfTestsWithOneRequestSubmitTestServer(maxNumberOfTestsWithOneRequestSubmitTestServer: number): SET_maxNumberOfTestsWithOneRequestSubmitTestServerAction {
  return {
    type: ActionType.SET_maxNumberOfTestsWithOneRequestSubmitTestServer,
    maxNumberOfTestsWithOneRequestSubmitTestServer
  }
}

export function setServerJustRunProgramTimeoutInMs(justRunProgramTimeoutInMs: number): SET_justRunProgramTimeoutInMsAction {
  return {
    type: ActionType.SET_justRunProgramTimeoutInMs,
    justRunProgramTimeoutInMs
  }
}

export function setJustRunProgramCompileTimeoutInMs(justRunProgramCompileTimeoutInMs: number): SET_justRunProgramCompileTimeoutInMsAction {
  return {
    type: ActionType.SET_justRunProgramCompileTimeoutInMs,
    justRunProgramCompileTimeoutInMs
  }
}

export function setServerJustRunProgramMemoryLimitInKb(justRunProgramMemoryLimitInKb: number): SET_justRunProgramMemoryLimitInKbAction {
  return {
    type: ActionType.SET_justRunProgramMemoryLimitInKb,
    justRunProgramMemoryLimitInKb
  }
}

export function setServerJustRunProgramMaxDiskSpaceInKb(justRunProgramMaxDiskSpaceInKb: number): SET_justRunProgramMaxDiskSpaceInKbAction {
  return {
    type: ActionType.SET_justRunProgramMaxDiskSpaceInKb,
    justRunProgramMaxDiskSpaceInKb
  }
}

export function setServerCustomProjectTestTimeoutInMs(customProjectTestTimeoutInMs: number): SET_customProjectTestTimeoutInMsAction {
  return {
    type: ActionType.SET_customProjectTestTimeoutInMs,
    customProjectTestTimeoutInMs
  }
}

export function setCustomProjectTestCompileTimeoutInMs(customProjectTestCompileTimeoutInMs: number): SET_customProjectTestCompileTimeoutInMsAction {
  return {
    type: ActionType.SET_customProjectTestCompileTimeoutInMs,
    customProjectTestCompileTimeoutInMs
  }
}

export function setServerCustomProjectTestMemoryLimitInKb(customProjectTestMemoryLimitInKb: number): SET_customProjectTestMemoryLimitInKbAction {
  return {
    type: ActionType.SET_customProjectTestMemoryLimitInKb,
    customProjectTestMemoryLimitInKb
  }
}

export function setServerCustomProjectTestMaxDiskSpaceInKb(customProjectTestMaxDiskSpaceInKb: number): SET_customProjectTestMaxDiskSpaceInKbAction {
  return {
    type: ActionType.SET_customProjectTestMaxDiskSpaceInKb,
    customProjectTestMaxDiskSpaceInKb
  }
}


export function setServerDefaultUserGroupId(defaultUserGroupId: number): SET_defaultUserGroupIdAction {
  return {
    type: ActionType.SET_defaultUserGroupId,
    defaultUserGroupId
  }
}

export function setServerDefaultGroupRoleId(defaultGroupRoleId: number): SET_defaultGroupRoleIdAction {
  return {
    type: ActionType.SET_defaultGroupRoleId,
    defaultGroupRoleId
  }
}

export function setServerDefaultGroupCreatorGroupRoleId(defaultGroupCreatorGroupRoleId: number): SET_defaultGroupCreatorGroupRoleIdAction {
  return {
    type: ActionType.SET_defaultGroupCreatorGroupRoleId,
    defaultGroupCreatorGroupRoleId
  }
}


export function loadSystemSettingsSite(): MultiActions {
  return async (dispatch, getState) => {

    dispatch(resetSystemSettingsSite())

    await dispatch(getInitialSystemSettingsAsync())
    await dispatch(getSystemSettingsAsync())

    await dispatch(getAllDefaultGroupsAsync())
    await dispatch(getAllDefaultRolesAsync())

  }
}

export function resetSystemSettingsSite(): ResetAction {
  return {
    type: ActionType.RESET
  }
}
